import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
//import javax.swing.border.*;

public class Intro extends JPanel{
  
  String INTRO_S = "<html><font size = +1><center>Color is everywhere, and we use it in so many " +
    "ways.  But how well do you understand it?</center></font>" +
    "<br><br><font size = +0>Have you noticed that when you mixed all of the paints in a " +
    "paint set you get a very dark color?  Yet mix a rainbow of colored light beams and you " + 
    "get white light. " +
    "<br><br>Explore the concepts of color and develop and refine your skills to create and " +
    "identify color. " +
    "<br><br>Begin with \"Compare Colors\" to see how colors mix with paint " +
    "pigments and light beams. " +
    "<br><br>Then select a color space to explore: " +
    "<br>&nbsp&nbsp&nbsp&nbsp Red - Green - Blue (RGB), " + 
    "<br>&nbsp&nbsp&nbsp&nbsp Cyan - Magenta - Yellow (CMY), or " +
    "<br>&nbsp&nbsp&nbsp&nbsp Hue - Saturation - Value (HSV). " +
    "<br><br>\"Make Colors\" in the color space to look for patterns, \"Play with Colors\" to " +
    "develop your skills, and finally \"Test Yourself\" to see how well you can " +
    "manipulate the color space." +
    "<br><br>Details about color spaces are available at " +
    "\"Color Info\".  If you like to know where you are going before you do it, " +
    "read this first.  If you like to see how well you figured out what you\'ve " +
    "explored, read this last.</font></html>";
  
  private JTabbedPane tabPane = null;

  public Intro(JTabbedPane tabbedPane, JComponent intro, int width, int height){
    //JComponent intro = makeTextPanel("Intro");
    System.out.println("In Intro");
    tabPane = tabbedPane;
    tabbedPane.addTab("Intro", intro);
    tabbedPane.setMnemonicAt(0, KeyEvent.VK_1);
    JLabel introLabel = new JLabel();
    JButton introButton = new JButton("Information About Color Spaces");
    
    intro.setBackground(Color.white);
    
    ShowImage picture = new ShowImage("docs/cb/images/1a.jpg", 250, 250);
    picture.setBounds(600, 20, width - 250, 265);
    picture.setVisible(true);
    intro.add(picture);
    
    ShowImage picture2 = new ShowImage("docs/cb/images/1b.jpg", 250, 250);
    picture2.setBounds(600, 285, width - 250, 265);
    picture2.setVisible(true);
    intro.add(picture2);
    
    intro.add(introLabel);
    introLabel.add(introButton);
    introButton.setVisible(true);
    
    JLabel introL = new JLabel(INTRO_S);
    introL.setBounds(100, 20, 450, 500);
    intro.add(introL);   
    
    introButton.setBounds(200, 540, width / 4, 25);
    intro.add(introButton);
    introButton.addActionListener(new IntroButton());
    
  }
    public class IntroButton implements ActionListener{

      public void actionPerformed(ActionEvent e){
        System.out.println(e.getSource());
        e.getSource();
        tabPane.setSelectedIndex(5);
      }
    }
   
}

